unit Unit1;

interface

uses
  System.SysUtils, System.Classes, WEBLib.Graphics, WEBLib.Forms, Vcl.StdCtrls,
  WEBLib.StdCtrls, Vcl.Controls, WEBLib.Dialogs, Vcl.Imaging.pngimage,
  WEBLib.ExtCtrls, WEBLib.Controls, Web, JS;

type
  TForm1 = class(TWebForm)
    WebLabel1: TWebLabel;
    WebButton1: TWebButton;
    WebEdit1: TWebEdit;
    WebRadioGroup1: TWebRadioGroup;
    WebLabel2: TWebLabel;
    WebLabel6: TWebLabel;
    [async]
    procedure WebButton1Click(Sender: TObject);
    procedure WebFormCreate(Sender: TObject);
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
  unit2;

{

Classic form loading without async methods

var
  newform: TForm2;

begin
  newform := TForm2.CreateNew(procedure(AForm: TObject)
    begin
      (AForm as TForm2).frm2Edit.Text := WebEdit1.Text;
    end
  );
  newform.Caption := 'Child form';

  case WebRadioGroup1.ItemIndex of
  0:
    begin
      newform.Border := fbSingle;
    end;
  1:
    begin
      newform.Popup := true;
    end;
  2:
    begin
      newform.Popup := true;
      newform.Border := fbDialog;
    end;
  3:
    begin
      newform.Popup := true;
      newform.Border := fbDialogSizeable;
    end;
  end;

  // used to manage Back button handling to close subform
  window.location.hash := 'subform';

  newform.ShowModal(procedure(AValue: TModalResult)
  begin
    ShowMessage('Form 2 closed with new value:'+newform.frm2Edit.Text);
    WebEdit1.Text := newform.frm2Edit.Text;
  end
  );

}

procedure TForm1.WebButton1Click(Sender: TObject);
var
  newform: TForm2;

begin
  newform := TForm2.Create(Self);
  newform.Caption := 'Child form';
  newform.Popup := WebRadioGroup1.ItemIndex <> 0;

  case WebRadioGroup1.ItemIndex of
  2: newform.Border := fbDialog;
  3: newform.Border := fbDialogSizeable;
  end;

  // used to manage Back button handling to close subform
  window.location.hash := 'subform';

  // load file HTML template + controls
  await(TForm2, newform.Load());

  // init control after loading
  newform.frm2Edit.Text := WebEdit1.Text;

  try
    // excute form and wait for close
    await(TModalResult, newform.Execute);
    ShowMessage('Form 2 closed with new value:"'+newform.frm2Edit.Text+'"');
    WebEdit1.Text := newform.frm2Edit.Text;
  finally
    newform.Free;
  end;
end;

procedure TForm1.WebFormCreate(Sender: TObject);
begin
  Application.ThemeColor := clTMSWEB;
end;

end.
